/***********      .---.         .-"-.      *******************\
* -------- *     /   ._.       /  ` \     * ---------------- *
* Author's *     \_  (__\      \_v_/     * humus@rogers.com *
*   note   *     //   \\       //   \\     * ICQ #47010716    *
* -------- *    ((     ))     ((     ))    * ---------------- *
*          ****--""---""-------""---""--****                  ********\
* This file is a part of the work done by Humus. You are free to use  *
* the code in any way you like, modified, unmodified or copy'n'pasted *
* into your own work. However, I expect you to respect these points:  *
*  @ If you use this file and its contents unmodified, or use a major *
*    part of this file, please credit the author and leave this note. *
*  @ For use in anything commercial, please request my approval.      *
*  @ Share your work and ideas too as much as you can.                *
\*********************************************************************/

#include "../Framework3/Direct3D/D3DApp.h"
#include "../Framework3/Util/Model.h"

#define STRAND_COUNT 1024
#define STRAND_LENGTH 64

#define INDEX_COUNT (STRAND_COUNT * 2 * (STRAND_LENGTH - 1))

#define R2VB_ENABLE  0x70ff0001
#define R2VB_DISABLE 0x70ff0000

#define R2VB_DMAP 0
#define R2VB_VTX0 1
#define R2VB_VTX1 2
#define R2VB_VTX2 3
#define R2VB_VTX3 4

#define R2VB_MAP_STREAM(stream, sampler) (0x71ff0000 | stream | (sampler << 4))
#define R2VB_UNMAP_STREAM(stream) (0x71ff0050 | stream)

class App : public D3DApp {
public:
	char *getTitle() const { return "Hair"; }

	void resetCamera();

	bool init();
	void exit();

	bool load();
	void unload();

	bool onReset();

	void drawEnvironment(const float4x4 &mvp);
	void drawFrame();

protected:
	TextureID hairPosRT[2], hairDirRT[2], hairFinalRT;
	SamplerStateID nearestClamp, trilinearAniso, linear, bilinearClamp;
	ShaderID initHair, hairPhysics, renderHair, renderHead, hairLighting, renderFloor;
	IndexBufferID hairIndices;
	VertexBufferID dummy;

	TextureID startHair;

	int currRT;

	VertexFormatID sbVF, quadVF, hairVF;
	TextureID env, head, floor;
	ShaderID lighting, skyBox;

	Model *model;

	bool needsInit;
};
